/**
 * \file <mi32/lidaruiformclassdescset.h>
 * \brief LIDAR::UI::FORM_CLASSDESCSET definitions
 *
 * \if NODOC
 * $Id: lidaruiformclassdescset.h_v 1.1 2011/07/15 17:04:16 mju Exp $
 *
 * $Log: lidaruiformclassdescset.h_v $
 * Revision 1.1  2011/07/15 17:04:16  mju
 * Initial revision
 *
 * Revision 1.2  2011/05/20 20:29:08  mju
 * Add getLabel.
 *
 * Revision 1.1  2011/03/28 15:59:47  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_LIDARUICLASSDESCSET_H
#define	INC_MI32_LIDARUICLASSDESCSET_H

#ifndef INC_MGUI_FORM_H
#include <mgui/form.h>
#endif


#ifndef GENERATING_DOXYGEN_OUTPUT
// Forward declarations.
namespace LIDAR {
	class CLASSDESCSET;
	}
namespace MGUI {
	class CTRL_LABEL;
	}
#endif


namespace LIDAR {
namespace UI {

//=====================================================================================================================

//! Form for LIDAR::CLASSDESCSET selection and editing.
class FORM_CLASSDESCSET : public MGUI::FORM_COMPOSITE {
	public:

		//! Constructor
		FORM_CLASSDESCSET ();

		//! Destructor.
		virtual ~FORM_CLASSDESCSET ();

		//! Create form.
		void Create (
			MGUI::LAYOUT_PANE_BASE& paneParent,
			const MISTRING& label,
			const char *IniName = 0
			);

		//! Get current class array.
		//! Must call Create before use.
		const CLASSDESCSET& GetClassDescSet () const;

		//! Get label for alignment.
		MGUI::CTRL_LABEL& GetLabel () const;

		//! Set delegate to call when array is changed.
		//! Must call Create before use.
		void SetDelegateOnChange (
			DELEGATE_VOID_NOPARMS delegate
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		#endif
	};

//=====================================================================================================================

}	// End namespace UI
}	// End namespace LIDAR

#endif	// INC_MI32_LIDARUICLASSDESCSET_H
