/**
 * \file mi32/mg2displaybuffer.h
 * \brief MGD::DEVICE_DISPLAYBUFFER definitions
 *
 * \if NODOC
 * $Id: mg2displaybuffer.h_v 1.2 2010/01/20 21:47:44 mju Exp $
 *
 * $Log: mg2displaybuffer.h_v $
 * Revision 1.2  2010/01/20 21:47:44  mju
 * Add isCreated.
 *
 * Revision 1.1  2010/01/20 20:57:37  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_MG2DISPLAYBUFFER_H
#define	INC_MI32_MG2DISPLAYBUFFER_H

#ifndef	INC_MI32_MG2X_H
#include <mi32/mg2x.h>
#endif

namespace MGUI {
	class CTRL;
	}

namespace MGD {
//=====================================================================================================================

class DEVICE_DISPLAYBUFFER : public MGD::DEVICE_X {
	public:
		//! Constructor.
		DEVICE_DISPLAYBUFFER ();

		//! Destructor.
		virtual ~DEVICE_DISPLAYBUFFER ();

		ERRVALUE Create (
			MGUI::CTRL& ctrl,			//!< Control to determine display from, must have been created and shown
			INT32 height,				//!< Initial device height in pixels
			INT32 width					//!< Initial device width in pixels
			);

		bool IsCreated (
			) const { return (m_pixmap != 0); }

		ERRVALUE Resize (
			INT32 height,				//!< New device height in pixels
			INT32 width					//!< New device width in pixels
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		Pixmap m_pixmap;

		DEVICE_DISPLAYBUFFER (const DEVICE_DISPLAYBUFFER&);
		DEVICE_DISPLAYBUFFER& operator= (const DEVICE_DISPLAYBUFFER&);
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

//=====================================================================================================================
}	// End namespace MGD

#endif	// INC_MI32_MG2DISPLAYBUFFER_H
