/********************************************************************************
 * cutfill.h - Raster cut / fill analysis 
 *
 * $Id: opcutfill.h_v 1.5 2011/05/31 19:43:48 mju Exp $
 *
 * $Log: opcutfill.h_v $
 * Revision 1.5  2011/05/31 19:43:48  mju
 * Clean up and define engine nested class.
 *
 * Revision 1.4  2007/08/20 14:55:37  honerkamp
 * Remove illegal qualifier
 *
 * Revision 1.1  2006/11/29 17:54:29  HONERKAMP
 * Initial revision
**********************************************************************************/

#ifndef	INC_RVC_OPCUTFILL_H
#define	INC_RVC_OPCUTFILL_H

#ifndef INC_RVC_DESCRIPTOR_H
#include <rvc/descriptor.h>
#endif

namespace RVC {

#ifndef GENERATING_DOXYGEN_OUTPUT
class OBJITEM;
#endif

namespace OP {

//! Class to compute the elevation differences between two rasters
class CUTFILL {
	public:
		//! Default constructor.
		CUTFILL();
		
		//! Compute the results.
		int Process (
			const RVC::OBJITEM &rast1,					//!< First input raster
			const RVC::OBJITEM &rast2,					//!< Second input raster
			RVC::OBJITEM *pObjItemBoundaries,		//!< Location of boundary vector, NULL to not compute
			RVC::OBJITEM *pObjItemDifference = 0	//!< Location of difference raster, NULL to not compute
			);

		//! Set the descriptor for the vector volume table.
		void SetTableDescriptor (
			const RVC::DESCRIPTOR &desc
			) { m_TableDescriptor = desc; }
		
	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class ENGINE;

		RVC::DESCRIPTOR m_TableDescriptor;
		#endif
	};

} //end namespace RVC
} //end namespace OP

#endif //INC_RVC_OPCUTFILL_H
